//
// backend-google.cs: Google backend.
//
// Authors:
//     Don Smith 
//

using System;
using System.IO;
using System.Xml;
using System.Collections;
using System.Net;

namespace Dashboard {

	class Google : BackendSimple {
		
		public override bool Startup ()
		{
			this.Name = "Google";
			this.Category = "General";

			try {
				// Subscribe to artist clues
				this.SubscribeToClues ("keyword");

				this.Initialized = true;

				return true;
			} catch {
				return false;
			}
		}

		protected override ArrayList ProcessClueSimple (Clue clue)
		{

		        int MAXRES=10;	
                        string devkey="";
                        string query=clue.Text;
                        int startresult=0;
                        int maxResults=MAXRES;
                        bool dupfilter=true;
                        string restrict="";
                        bool safeSearch=true;
                        string languagerestrict="";
                        string inputencoding=""; 
                        string outputencoding="";
			ArrayList results = new ArrayList();
                        GoogleSearchResult gsr;
                        GoogleSearchService searchService = new GoogleSearchService(); 

                        if (! this.Initialized)
				return null;

			if (clue.Text.Length == 0)
				return null;

                        try{
                        gsr=searchService.doGoogleSearch(devkey, query, startresult, maxResults, dupfilter, restrict, safeSearch, languagerestrict, inputencoding, outputencoding); 
                        }catch{

                        return null;

                        }
                        for (int i=0; i<MaxRes; i++){
                        BackendResult GoogleResult = new BackendResult();
                        GoogleResult.AddItem( new BackendResultItem("GoogleResult",gsr.resultElements[i].title, "text", "html", gsr.resultElements[i].URL ));
                        results.Add(GoogleResult); 


                        }
			if (results.Count > 0) {
				return results;
			} else {
				return null;
			}
                return null;
                }	


     }
}
